// BmpFileViewDlg.h : header file
//

#if !defined(AFX_BMPFILEVIEWDLG_H__1A8FF8FA_B355_4373_A9FE_E0AB10000316__INCLUDED_)
#define AFX_BMPFILEVIEWDLG_H__1A8FF8FA_B355_4373_A9FE_E0AB10000316__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TLFrame.h"	//TreeList control
//#include "TreeToolTipCtrl.h"	// TreeList ؼ Tooltip

#include "BmpFile.h"	//bmp file 
#include "IcoFile.h"	//ico file
#include "PeFile.h"		//exe|dll|ocx file
#include "PsdFile.h"	//photoshop file
//#include "ximage.h"		//CxImage
#include "afxwin.h"

/////////////////////////////////////////////////////////////////////////////
// CBmpFileViewDlg dialog

class CBmpFileViewDlg : public CDialog
{
// Construction
public:
	CBmpFileViewDlg(CWnd* pParent = NULL);	// standard constructor
	void GetItemRect(int ctlId, LPRECT lpRect);

// Dialog Data
	//{{AFX_DATA(CBmpFileViewDlg)
	enum { IDD = IDD_BMPFILEVIEW_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBmpFileViewDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:	
	//ͼƬ
	enum _IMAGE_INDEXES
	{
		IMAGEINDEX_FOLDER	= 0,
		IMAGEINDEX_FILE		= 1,
		IMAGEINDEX_RGBQUAD	= 2, //RGBQUAD, 4 bytes
		IMAGEINDEX_BYTE		= 3, //int8,  1 bytes
		IMAGEINDEX_WORD		= 4, //int16, 2 bytes
		IMAGEINDEX_DWORD	= 5, //int32, 4 bytes
		IMAGEINDEX_LONGLONG = 6, //int64, 8 bytes
	};
protected:
	BOOL MyAddSeconds(const SYSTEMTIME *lpSrcTime, SYSTEMTIME *lpDestTime, int seconds);
	void FillTreeList(CBmpFile* pBmp);
	void FillTreeList(CIcoFile* pIco);
	void FillTreeList(CPeFile* pPe);
	void FillTreeList(CPsdFile* pPsd);
	HICON m_hIcon;

	//treelistؼ
	CTLFrame m_wndMyTreeList; 

	//ڵͼͼƬ
	CImageList m_cImageList;

	//ļʽ
	CBmpFile *m_pBmp;
	CIcoFile *m_pIco;
	CPeFile *m_pPe;
	CPsdFile *m_pPsd;

	//Ԥõλͼ
	//CxImage m_CxImage;

private:
	HTREEITEM Append_BYTE(LPCTSTR name, BYTE val, size_t* pAddress,
		HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
		LPCTSTR memo = NULL);

	HTREEITEM Append_WORD(LPCTSTR name, WORD val, size_t* pAddress,
		HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
		LPCTSTR memo = NULL);

	HTREEITEM Append_DWORD(LPCTSTR name, DWORD val, size_t* pAddress,
		HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
		LPCTSTR memo = NULL);

	HTREEITEM Append_LONG(LPCTSTR name, LONG val, size_t* pAddress,
		HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
		LPCTSTR memo = NULL);

	//һchar[8] (PEʽеĽ)
	HTREEITEM Append_CHAR8(LPCTSTR name, BYTE szVal[], size_t* pAddress,
		HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
		LPCTSTR memo = NULL);

	//һRGBQUADڵ
	HTREEITEM Append_RGBQUAD(LPCTSTR name, RGBQUAD* pQuad, size_t* pAddress,
		HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree);

	HTREEITEM Append_LPVOID(LPCTSTR name, size_t nSize, LPCTSTR type, size_t* pAddress,
		HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
		LPCTSTR memo = NULL, int nImage = IMAGEINDEX_FILE);

	HTREEITEM Append_STRUCT(LPCTSTR name, size_t nSize, LPCTSTR type, size_t* pAddress,
		HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree,
		LPCTSTR memo = NULL, int nImage = IMAGEINDEX_FOLDER);

	// BITMAPINFO һڵ, BitmapInfoڵ
	HTREEITEM Append_BITMAPINFO(LPCTSTR name, 
		LPBITMAPINFO lpInfo, int paletteSize, size_t* pAddress,
		HTREEITEM hParent, HTREEITEM hInsertAfter, CTreeListCtrl& _tree);


	// Generated message map functions
	//{{AFX_MSG(CBmpFileViewDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOpenimage();
	afx_msg void OnAbout();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	// ıؼ
	CEdit m_Edit;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BMPFILEVIEWDLG_H__1A8FF8FA_B355_4373_A9FE_E0AB10000316__INCLUDED_)
